class NaryConstraint;
class NaryVariable;

/* CSP n-aires en extension rsolus en Max-CSP avec poids sur les n-uplets*/
/** NaryCSPs solved as weighted Max-CSPs with weights on the tuples */
class NaryCSProblem : public CSProblem
{ public :
  vector<NaryConstraint*>* naryconstraints;
  vector<NaryVariable*>*   naryvariables;
  NaryCSProblem( int nbvar, int nbconst);
  NaryCSProblem (int nbvar, int nbconst, int lower);
  ~NaryCSProblem() {;};
  // int move_evaluation(Configuration* configuration,Move* move);
  // void compute_var_conflict(Configuration* configuration);
/* evaluation et remplissage de la structure de donnes des conflits*/
/** evaluation and filling the conflict datastructure */
  int config_evaluation(Configuration* configuration);
  void fullincr_update_conflicts(FullincrCSPConfiguration* configuration,Move* move);
/* calcul du nombre de conflits d'une affectation simple dans une configuration */
/** number of conflicts of a simple assignment in a complete configuration */
  int compute_conflict(Configuration* configuration, int var , int val);
  // void compute_var_conflict(Configuration* configuration);
void incr_update_conflicts (IncrCSPConfiguration* configuration, Move* move);
// int move_evaluation  (Configuration* configuration,Move* move);
/* choix du mode d'incrmentalit : IncrCSPConfiguration ou FullincrCSPConfiguration */
/** choice of incrementality mode : IncrCSPConfiguration ou FullincrCSPConfiguration */
Configuration* NaryCSProblem::create_configuration();
};

/* Contrainte N-aire en extension avec poids sur les n-uplets qui violent la contrainte */
/** Nary constraint in extension with weigths defined on the tuples */
class NaryConstraint
{ public :
  int arity;
  NaryConstraint (int arit);
/* evaluation de la contrainte : recherche dans le tableau des n-uplets */
/** Constraint Evalution : searching in the tuple table */
  int constraint_value (Configuration* configuration);
  int compute_index(int* values, vector<int>* tabdomaines);
  int compute_indexpart (int i, int vali, vector<int>* tabdomaines);
/* variables lies par la contraintes */
/** variables linked by the constraint */
  vector <int>  constrainedvariables;
/* table des n-uplets valus */
/** table of valued tuples */
  vector <int> tuplevalues;
  vector <int> multiplyers;
  void compute_indexmultiplyers( vector<int>* tabdomaines);
  int compute_indexmultiplyer(int i, vector<int>* tabdomaines);
  int nbtuples(vector<int>* tabdomaines );
};

/* Variable lie  une contrainte n-aire */
/** Variable constrained by a n-ary constraint */
class NaryVariable
{public :
  vector <NaryConstraint*> constraints;
  NaryVariable();
};

NaryCSProblem* weighted_narycsp_creation (int nbvar, int nbconst, int maxdomsize, 
 vector<NaryVariable*>* vv,vector<NaryConstraint*>* vct     );

void wcspdomaines_file_read (ifstream & file, int nbvar, vector<int>* tabdomaines);

void  wcspdata_constraint_read (ifstream & file, int nbconst, vector<NaryVariable*>* vv, vector<NaryConstraint*>* vct, 
				vector <int>* connexions, vector<int> * tabdomaines);


int narycsp(int argc, char** argv, int tuningmode);